function love.load()
  -- <...loading...>
  cursor = love.graphics.newImage('cursor.gif')
  cursor2 = love.graphics.newImage('cursor2.gif')
  cursor0 = love.graphics.newImage('cursor0.gif')
  hpbar = love.graphics.newImage('HPbar.gif')
  hpbg = love.graphics.newImage('HPbg.gif')
  speedometer = love.graphics.newImage('PonF.png')
  lancetta = love.graphics.newImage('lancetta.png')
  love.graphics.newFont('visitor1.ttf', 16)
  -- <loaded>
  -- <...setting...>
  x = 100
  y = 100
  alternate = 1
  thrust = 14
  angle = 0
  hp = 100
  fuel = 10000
  toggle_thrust = 0
  toggle_stop = 0
  toggle_turnleft = 0
  toggle_turnright = 0
  img = cursor0
  x_speed = 0
  y_speed = 0
  x_thrust = 0
  y_thrust = 0
  x_sin = 0
  y_cos = 0
  old_x_sin = 0
  old_y_cos = 0
  -- <set>
  love.graphics.setColor(255,255,255,160)
  love.graphics.setFont('visitor1.ttf', 16)
end

-- <...creating custom function...>
function shoot()
  love.graphics.print("Don't.", 232, 244)
end
-- <created>
-- <...receiving human input...>
function love.keypressed(key)

  if key == 'up' then
    toggle_thrust = 1
  end

  if key == 'down' then
    toggle_stop = 1
    timer_stop  = 30
  end

  if key == 'left' then
    toggle_turnleft = 1
  end

  if key == 'right' then
    toggle_turnright = 1
  end

  if key == ' ' then
    shoot()
  end
  -- <...receiving debug input...>
  if key == 'd' then
    hp = hp - 10
    fuel = fuel - 10000
  end

  if key == 'r' then
    hp = 100
    fuel = 10000
  end
  -- <received>
end
function love.keyreleased(keyr)

  if keyr == 'up' then
    toggle_thrust = 0
    old_x_sin = math.sin(math.rad(angle))
    old_y_cos = math.cos(math.rad(angle-180))
  end

  if keyr == 'down' then
    toggle_stop = 0
  end

  if keyr == 'left' then
    toggle_turnleft = 0
  end

  if keyr == 'right' then
    toggle_turnright = 0
  end

end

function love.update(dt)
  x_sin = math.sin(math.rad(angle))
  y_cos = math.cos(math.rad(angle-180))
  if angle > 360 then 
    angle = 0
  elseif angle < -360 then
    angle = 0
  end
  -- <...handling human input...>
  if toggle_thrust == 0 then
    fuel = fuel + 5
    if fuel > 10000 then 
      fuel = 10000 
    end
    img = cursor0
  end
  if toggle_thrust == 1 then
    if fuel > 0 then
      x_thrust = thrust*x_sin
      y_thrust = thrust*y_cos
      fuel = fuel - 15
      if alternate == 2 then
        img = cursor2
      elseif alternate == 1 then
        img = cursor
      end
    else img = cursor x_thrust = 0 y_thrust = 0 fuel = 0 end
    alternate = alternate + 1
    if alternate == 3 then alternate = 1 end
  end
  if toggle_stop == 1 then
    x_speed = (x_speed/30)*timer_stop
    y_speed = (y_speed/30)*timer_stop
    timer_stop = timer_stop - 1
    if timer_stop < 0 then
      timer_stop = 0
    end
  end 
  if toggle_stop == 0 and toggle_thrust == 0 then
    x_thrust = 0
    y_thrust = 0
  end

  if toggle_turnleft == 1 then
    angle = angle - 120*dt
  end

  if toggle_turnright == 1 then
    angle = angle + 120*dt
  end
  -- <handled>
  x_speed = x_speed + x_thrust*dt
  y_speed = y_speed + y_thrust*dt
  -- <...limiting speed...>
--[[  if x_speed > 55*old_x_sin+1 then x_speed = 55*old_x_sin end
  if y_speed > 55*old_y_cos+1 then y_speed = 55*old_y_cos end
  if x_speed < -55*old_x_sin-1 then
    x_speed = -55*old_x_sin
  end
  if y_speed < -55*old_y_cos-1 then
    y_speed = -55*old_y_cos
  end]]
  if x_speed > 30 then
    x_speed = 30 
  elseif x_speed < -30 then
    x_speed = -30 
  end
  if y_speed > 30 then 
    y_speed = 30 
  elseif y_speed < -30 then 
    y_speed = -30 
  end
  -- <limited>
  x = x + x_speed*dt*10
  y = y + y_speed*dt*10
  -- <Warping!>
  if x < -8 then 
    x = 512 
  end 

  if x > 512 then 
    x = 1 
  end 

  if y < -8 then 
    y = 512 
  end 

  if y > 512 then 
    y = 1 
  end
  dt_ = dt
end

function love.draw()
  if hp < 1 then
    love.graphics.print('Game Over', 128, 216, 0, 3.1, 3.1)
  else love.graphics.setColor(255,255,255,255)
    love.graphics.draw(img, x, y, (math.rad(angle)), 1, 1, 16, 16)
    love.graphics.setColor(255,255,255,160)
    love.graphics.draw(hpbg, 16, 16, 0, 1, 0.5)
    love.graphics.draw(hpbar, 16, 16, 0, hp/100, 0.5)
    love.graphics.printf(hp, 16, 16, 512)
    love.graphics.printf(fuel/100 .. '%', 16, 32, 512)
    love.graphics.draw(speedometer, 384, 384)
    --[[love.graphics.print(y_speed, 16, 96)
    love.graphics.print(x_speed, 16, 80)
    love.graphics.print(x_thrust, 16, 48)
    love.graphics.print(y_thrust, 16, 64)
    love.graphics.print(x, 16, 112)
    love.graphics.print(y, 16, 128)
    love.graphics.print(math.rad(angle), 16, 144)
    love.graphics.print(x_sin, 16, 160)
    love.graphics.print(y_cos, 16, 176)]]
    love.graphics.printf('P/F', 308+128, 384+108, 512)
  end
end
    
